#include <stdio.h>
#include <ldap.h>

#define ADMINDN "uid=cyoun, ou=People, o=npac.syr.edu"
#define ADMINPW "cyoun.user"
#define ENTRYDN "cn=Choonhan Youn, ou=Gateway, o=npac.syr.edu"

#define LDHOST "merkury.npac.syr.edu"
#define LDPORT 1389


main()
{
  LDAP *ld;
  char *cnvals[2], *snvals[2], *ocvals[2];
  LDAPMod cnmod, snmod, ocmod;
  LDAPMod *mods[4];


  if((ld = ldap_init( LDHOST, LDPORT)) == NULL)
    {
      perror("ldap_init");
      exit(1);
    }

  if (ldap_simple_bind_s(ld, ADMINDN, ADMINPW) != LDAP_SUCCESS)
    {
      ldap_perror(ld, "ldap_simple_bind_s");
      exit(1);
    }

  cnvals[0] = "Choonhan Youn";
  cnvals[1] = NULL;
  cnmod.mod_op = 0;
  cnmod.mod_type = "cn";
  cnmod.mod_values = cnvals;
  snvals[0] = "Youn";
  snvals[1] = NULL;
  snmod.mod_op = 0;
  snmod.mod_type = "sn";
  snmod.mod_values = snvals;
  ocvals[0] = "top";
  ocvals[1] = "person";
  ocvals[2] = NULL;
  ocmod.mod_op = 0;
  ocmod.mod_type = "objectclass";
  ocmod.mod_values = ocvals;
  mods[0] = &cnmod;
  mods[1] = &snmod;
  mods[2] = &ocmod;
  mods[3] = NULL;

  if ( ldap_add_s( ld, ENTRYDN, mods) != LDAP_SUCCESS ) 
    {
      ldap_perror( ld, "ldap_add");
      exit(1);
    }

  ldap_unbind(ld);
  return(0);
}
